package com.wd.workoffice.ui.activity.bat.order.sale;

import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.alibaba.fastjson.JSON;
import com.wd.workoffice.R;
import com.wd.workoffice.app.BaseBean;
import com.wd.workoffice.app.WorkToolBarActivity;
import com.wd.workoffice.bean.OrderDetail;
import com.wd.workoffice.bean.event.CheckTicketEvent;
import com.wd.workoffice.retrofit.RtfUtils;
import com.wd.workoffice.retrofit.WorkObserver;
import com.wd.workoffice.ui.activity.bat.order.EndApplyActivity;
import com.wd.workoffice.ui.activity.bat.order.SendApplyActivity;
import com.wd.workoffice.ui.adapter.OrderDetailProductAdapter;
import com.wd.workoffice.ui.adapter.OrderProcessAdapter;
import com.wd.workoffice.util.WorkUtils;

import org.greenrobot.eventbus.EventBus;

import java.util.ArrayList;
import java.util.List;

import androidx.appcompat.app.AlertDialog;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import flexible.xd.android_base.network.rtfhttp.Transformer;
import io.reactivex.Observable;
import io.reactivex.disposables.Disposable;

/**
 * 销售订单详情
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class SaleOrderDetailActivity extends WorkToolBarActivity {
    @BindView(R.id.tv_status)
    TextView tvStatus;
    @BindView(R.id.tv_desc)
    TextView tvDesc;
    @BindView(R.id.ll_top)
    RelativeLayout llTop;
    @BindView(R.id.tv_refuse)
    TextView tvRefuse;
    @BindView(R.id.tv_agree)
    TextView tvAgree;
    @BindView(R.id.ll_bottom)
    LinearLayout llBottom;
    @BindView(R.id.rv_process)
    RecyclerView rvProcess;
    @BindView(R.id.tv_name)
    TextView tvName;
    @BindView(R.id.tv_dep)
    TextView tvDep;
    @BindView(R.id.tv_place_name)
    TextView tvPlaceName;
    @BindView(R.id.tv_company)
    TextView tvCompany;
    @BindView(R.id.tv_order_no)
    TextView tvOrderNo;
    @BindView(R.id.tv_time)
    TextView tvTime;
    @BindView(R.id.tv_send_time)
    TextView tvSendTime;
    @BindView(R.id.tv_order_price)
    TextView tvOrderPrice;
    @BindView(R.id.rv_pro)
    RecyclerView rvPro;
    @BindView(R.id.tv_claim1)
    TextView tvClaim1;
    @BindView(R.id.tv_claim2)
    TextView tvClaim2;
    @BindView(R.id.tv_claim3)
    TextView tvClaim3;
    @BindView(R.id.tv_claim4)
    TextView tvClaim4;
    @BindView(R.id.tv_claim5)
    TextView tvClaim5;
    @BindView(R.id.tv_claim6)
    TextView tvClaim6;
    @BindView(R.id.tv_finish_apply)
    TextView tvFinishApply;
    @BindView(R.id.tv_send_apply)
    TextView tvSendApply;
    @BindView(R.id.ll_sale)
    LinearLayout llSale;
    @BindView(R.id.ll_check)
    LinearLayout llCheck;
    @BindView(R.id.ll_apply)
    LinearLayout llApply;
    private OrderDetail dataBean;
    private List<OrderDetail.OrderFlowsBean> flowList;
    private OrderProcessAdapter flowAdapter;
    private OrderDetailProductAdapter proAdapter;
    private List<OrderDetail.OrderItemsBean> proList;
    private Integer status;

    @Override
    protected void initView() {
        ButterKnife.bind(this);
        rvPro.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        rvProcess.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
        status = Integer.valueOf(getIntent().getStringExtra("status"));
        switch (status) {
//            private String tab[] = {
//            "全部", "待审核", "待接单", "待生产", "已入库",
//            "已交付"};
//    private String order[] = {
//            "", "100", "200", "710", "500",
//            "600"};
            case 100:
                llBottom.setVisibility(View.VISIBLE);
                llApply.setVisibility(View.VISIBLE);
                break;
            case 200:
                break;
            case 300:
                llBottom.setVisibility(View.VISIBLE);
                llApply.setVisibility(View.VISIBLE);
                break;
            case 410:
                llBottom.setVisibility(View.VISIBLE);
                llApply.setVisibility(View.VISIBLE);
                break;
            case 500:
                llBottom.setVisibility(View.VISIBLE);
                llApply.setVisibility(View.VISIBLE);
                break;
            case 600:
                llBottom.setVisibility(View.VISIBLE);
                llApply.setVisibility(View.VISIBLE);
                break;
            default:
                llBottom.setVisibility(View.VISIBLE);
                llApply.setVisibility(View.VISIBLE);
                break;
        }
    }

    @Override
    protected void initData() {
        getData();
        flowList = new ArrayList<>();
        flowAdapter = new OrderProcessAdapter(R.layout.item_order_process, flowList);
        flowAdapter.bindToRecyclerView(rvProcess);
        flowAdapter.setEmptyView(R.layout.view_empty_order, rvProcess);
        proList = new ArrayList<>();
        proAdapter = new OrderDetailProductAdapter(R.layout.item_order_product, proList, status);
        proAdapter.bindToRecyclerView(rvPro);
        proAdapter.setEmptyView(R.layout.view_empty_order, rvProcess);
    }

    private void getData() {
        RtfUtils.getRtf().saleOrderDetail(getIntent().getStringExtra("id"), "3").compose(Transformer.schedule()).subscribe(new WorkObserver<BaseBean>() {

            @Override
            public void doOnSubscribe(Disposable d) {
            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseBean data) {
                hideLoading();
                if (data.getCode() != 0) {
                    toast(data.getMessage());
                    return;
                }
                dataBean = JSON.parseObject(data.getData().toString(), OrderDetail.class);
                flowList.addAll(dataBean.getOrderFlows());
                flowAdapter.notifyDataSetChanged();
                proList.addAll(dataBean.getOrderItems());
                proAdapter.notifyDataSetChanged();
                tvName.setText(dataBean.getCustomerName());
                tvDep.setText(dataBean.getReceiveDeptName());
                tvStatus.setText(dataBean.getStatusName());
                tvPlaceName.setText(dataBean.getLaunchUserName());
                tvCompany.setText(dataBean.getLaunchDeptName());
                tvOrderNo.setText(dataBean.getId());
                tvTime.setText(dataBean.getCreatedTime());
                tvSendTime.setText(dataBean.getRequireTime());
                tvDesc.setText(dataBean.getAttrName());
                tvOrderPrice.setText(String.valueOf(dataBean.getLaunchOrderAmount()));

                OrderDetail.ExpandInfoBean expandInfo = dataBean.getExpandInfo();
                tvClaim1.setText(expandInfo.getDemond4());
                tvClaim2.setText(expandInfo.getDemond5());
                tvClaim3.setText(expandInfo.getDemond1());
                tvClaim4.setText(expandInfo.getDemond2());
                tvClaim5.setText(expandInfo.getDemond3());
                tvClaim6.setText(expandInfo.getComments());

                tvDesc.setText(dataBean.getAttrName());
                tvStatus.setText(dataBean.getStatusName());
            }
        });
    }

    @Override
    protected void initEvent() {
    }

    @Override
    protected int layoutId() {
        return R.layout.activity_sale_order;
    }


    @OnClick({R.id.tv_finish_apply, R.id.tv_send_apply, R.id.tv_refuse, R.id.tv_agree})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.tv_refuse:
                break;
            case R.id.tv_agree:
                break;
            case R.id.tv_finish_apply:
                if (dataBean == null) {
                    toast("正在加载中，请稍后");
                    return;
                }
                startActivity(EndApplyActivity.class,
                        "status", getIntent().getStringExtra("status"),
                        "orderType", dataBean.getOrderType(),
                        "orderId", getIntent().getStringExtra("id"));
                break;
            case R.id.tv_send_apply:
                startActivity(SendApplyActivity.class, "orderId", getIntent().getStringExtra("id"));
                break;
        }
    }


}
